"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ts = __importStar(require("typescript"));
var path_1 = require("path");
var slash = require("slash");
var transformer = function (_) {
    return function (context) { return function (rootNode) {
        var compilerOptions = context.getCompilerOptions();
        // TODO should check if baseUrl and paths are defined
        var baseUrl = compilerOptions.baseUrl;
        var paths = compilerOptions.paths;
        var regPaths = Object.keys(paths).map(function (key) { return ({
            regexp: new RegExp("^" + key.replace("*", "(.*)") + "$"),
            resolve: paths[key][0] // TODO should check if is not empty
        }); });
        var fileDir = "";
        function findFileInPaths(text) {
            for (var _i = 0, regPaths_1 = regPaths; _i < regPaths_1.length; _i++) {
                var path = regPaths_1[_i];
                var match = text.match(path.regexp);
                if (match) {
                    var out = path.resolve.replace(/\*/g, match[1]);
                    var file = slash(path_1.relative(fileDir, path_1.resolve(baseUrl, out)));
                    return file;
                }
            }
            return null;
        }
        function visit(node) {
            if (ts.isSourceFile(node)) {
                fileDir = path_1.dirname(node.fileName);
                return ts.visitEachChild(node, visit, context);
            }
            if (ts.isImportDeclaration(node) &&
                ts.isStringLiteral(node.moduleSpecifier)) {
                var file = findFileInPaths(node.moduleSpecifier.text);
                if (file) {
                    return ts.updateImportDeclaration(node, node.decorators, node.modifiers, node.importClause, 
                    // If it's in the same level or below add the ./
                    ts.createLiteral(file[0] === "." ? file : "./" + file));
                }
            }
            if (ts.isExportDeclaration(node) &&
                node.moduleSpecifier &&
                ts.isStringLiteral(node.moduleSpecifier)) {
                var file = findFileInPaths(node.moduleSpecifier.text);
                if (file) {
                    return ts.updateExportDeclaration(node, node.decorators, node.modifiers, node.exportClause, 
                    // If it's in the same level or below add the ./
                    ts.createLiteral(file[0] === "." ? file : "./" + file));
                }
            }
            return ts.visitEachChild(node, visit, context);
        }
        return ts.visitNode(rootNode, visit);
    }; };
};
exports.default = transformer;
